-- dati su ovi tipovi
type Point = (Int, Int)
data Quadrant = Q1 | Q2 | Q3 | Q4 deriving Show
-- definisati nov tip
type QuadrantPoints = ([Point], [Point], [Point], [Point])

-- pristupanje koordinatama
get :: Quadrant -> QuadrantPoints -> [Point]
get Q1 (a, _, _, _) = a
get Q2 (_, b, _, _) = b
get Q3 (_, _, c, _) = c
get Q4 (_, _, _, d) = d

-- postavljanje koordinata
set :: [Point] -> Quadrant -> QuadrantPoints -> QuadrantPoints
set a' Q1 (_, b, c ,d) = (a', b, c, d)
set b' Q2 (a, _, c, d) = (a, b', c, d)
set c' Q3 (a, b, _, d) = (a, b, c', d)
set d' Q4 (a, b, c, _) = (a, b, c, d')

-- definisati xAxis i yAxis
xAxis :: Point -> Bool
xAxis = \p -> snd p == 0
yAxis :: Point -> Bool
yAxis = \p -> fst p == 0

-- definisati onAxis predikat (za potrebe filtera)
onAxis :: Point -> Bool
onAxis p = xAxis p || yAxis p

-- definisati getQuadrant
getQuadrant :: Point -> Maybe Quadrant
getQuadrant (x, y)
  | x > 0 && y > 0 = Just Q1
  | x < 0 && y > 0 = Just Q2
  | x < 0 && y < 0 = Just Q3
  | x > 0 && y < 0 = Just Q4
  | otherwise = Nothing

-- kreirati funkciju koja pravi listu svih tačaka koje imaju celobrojne koordinate, a
-- koje pripadaju pravougaoniku čija temena takođe imaju celobrojne koordinate, a čiji
-- se opsezi zadaju kao argumenti funkcije: X_min, Y_min, X_max, Y_max

pointsFromRect :: Int -> Int -> Int -> Int -> [Point]
pointsFromRect xmin ymin xmax ymax = [(x, y) | x <- [xmin..xmax], y <- [ymin..ymax]]

-- 
accumulate :: (Point, Maybe Quadrant) -> QuadrantPoints -> QuadrantPoints
accumulate (p, Just q) acc = set (p : get q acc) q acc

groupByQuadrants :: [Point] -> QuadrantPoints
groupByQuadrants ps =
  foldr accumulate ([], [], [], []) $
  map (\p -> (p, getQuadrant p)) $
  filter (\p -> not $ onAxis p) ps



